----------------------------------------------------------------------------------
-- Test bench for pulse generator 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity pulse_gen_tb is
--  Port ( );
end pulse_gen_tb;

architecture Behavioral of pulse_gen_tb is

    constant clock_period : time := 10 ns;
    signal clock, reset, PS2CLK_S, pulse : std_logic;
    
begin
    UUT: entity work.pulse_gen(Behavioral)
    port map(
        clock => clock,
        reset => reset, 
        PS2_CLK_S => PS2CLK_S,
        pulse => pulse
    );
    
    -- Stimuli
    stimuli_clk: process 
    begin 
        clock <= '0';
        wait for clock_period/2;
        clock <= '1';
        wait for clock_period/2;
    end process;
    
    stimuli_other: process 
    begin
        -- Long reset 
        reset <= '1';
        PS2CLK_S <= '1'; -- idle state
        wait for clock_period*4;
        
        -- Remove reset 
        reset <= '0';
        wait for clock_period*4;
        
        -- Generate periodic signal PS2CLK_S
             
        for i in 1 to 3 loop 
            PS2CLK_S <= '0';
            wait for clock_period*7;
            PS2CLK_S <= '1';
            wait for clock_period*7;
        end loop;
        
        -- Wait forever 
        wait; 
        
    end process;
    

end Behavioral;
