----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 02.12.2022 08:55:34
-- Design Name: 
-- Module Name: PS2Controller - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity PS2Controller is
    port (
        PS2_CLK : in STD_LOGIC;
        PS2_DATA : in STD_LOGIC;
        CLK100MHZ : in STD_LOGIC;
        CPU_RESETN : in STD_LOGIC;
        data : out STD_LOGIC_VECTOR (8 downto 0);
        eot : out STD_LOGIC);
end PS2Controller;

architecture Behavioral of PS2Controller is
    signal clock, reset, we : std_logic;
    signal PS2_CLK_q, PS2_CLK_S, PS2_DATA_q, PS2_DATA_S, pulse : std_logic;
begin
    clock <= CLK100MHZ; 
    reset <= not CPU_RESETN;
    
    -- Synchronizers for external signals
    sync_clk_data: process (clock) 
    begin 
        if rising_edge(clock) then 
            if reset = '1' then 
                PS2_CLK_q <= '1';
                PS2_CLK_S <= '1';
                PS2_DATA_q <= '1';
                PS2_DATA_S <= '1';                
            else 
                PS2_CLK_q <= PS2_CLK;
                PS2_CLK_S <= PS2_CLK_q;
                PS2_DATA_q <= PS2_DATA;
                PS2_DATA_S <= PS2_DATA_q;
            end if; 
        end if;      
    end process;
    
    pulse_gen: entity work.pulse_gen(Behavioral)
    port map(
        clock => clock,
        reset => reset,
        PS2_CLK_S => PS2_CLK_S,
        pulse => pulse
    );
    
    control_unit: entity work.control_unit (Behavioral)
    port map(
        clock => clock,
        reset => reset,
        PS2_DATA_S => PS2_DATA_S,
        pulse => pulse,
        we => we,
        eot => eot
    );
    
    SIPO: entity work.SIPO (Behavioral)
    port map(
        clock => clock,
        reset => reset,
        PS2_DATA_S => PS2_DATA_S,
        we => we,
        data => data
    );

end Behavioral;
