----------------------------------------------------------------------------------
-- Serial in Parallel Out shift register
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity SIPO is
    port (
        clock : in STD_LOGIC;
        reset : in STD_LOGIC;
        PS2_DATA_S : in STD_LOGIC;
        we : in std_logic;
        data : out STD_LOGIC_VECTOR (8 downto 0));
end SIPO;

architecture Behavioral of SIPO is
    signal data_i : std_logic_vector(data'length-1 downto 0);
begin

    data <= data_i;
    
    process (clock)
    begin
        if rising_edge(clock) then
            if reset = '1' then
                data_i <= (others=> '0');
            else
                if we = '1' then
                    -- shift for one place to the right 
                    --data_i(data'length-2 downto 0) <= data_i(data'length-1 downto 1);
                    -- store a bit in the MSB position 
                    --data_i(data'length-1) <= PS2_DATA_S;
                    
                    -- Alternative: use concatenation operator
                    data_i <= PS2_DATA_S & data_i(data'length-1 downto 1);
                end if;
            end if;
        end if;

    end process;

end Behavioral;
